/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(MEDIA_STREAM)

#include "JSDOMConvertDictionary.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "JSEventTarget.h"
#include "MediaDevices.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSMediaDevices : public JSEventTarget {
public:
    using Base = JSEventTarget;
    using DOMWrapped = MediaDevices;
    static JSMediaDevices* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<MediaDevices>&& impl)
    {
        JSMediaDevices* ptr = new (NotNull, JSC::allocateCell<JSMediaDevices>(globalObject->vm().heap)) JSMediaDevices(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static MediaDevices* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    MediaDevices& wrapped() const
    {
        return static_cast<MediaDevices&>(Base::wrapped());
    }
protected:
    JSMediaDevices(JSC::Structure*, JSDOMGlobalObject&, Ref<MediaDevices>&&);

    void finishCreation(JSC::VM&);
};

class JSMediaDevicesOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&, const char**);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, MediaDevices*)
{
    static NeverDestroyed<JSMediaDevicesOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(MediaDevices* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, MediaDevices&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, MediaDevices* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<MediaDevices>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<MediaDevices>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<MediaDevices> {
    using WrapperClass = JSMediaDevices;
    using ToWrappedReturnType = MediaDevices*;
};
#if ENABLE(MEDIA_STREAM)

String convertEnumerationToString(MediaDevices::DisplayCaptureSurfaceType);
template<> JSC::JSString* convertEnumerationToJS(JSC::JSGlobalObject&, MediaDevices::DisplayCaptureSurfaceType);

template<> Optional<MediaDevices::DisplayCaptureSurfaceType> parseEnumeration<MediaDevices::DisplayCaptureSurfaceType>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<MediaDevices::DisplayCaptureSurfaceType>();

#endif

#if ENABLE(MEDIA_STREAM)

template<> MediaDevices::StreamConstraints convertDictionary<MediaDevices::StreamConstraints>(JSC::JSGlobalObject&, JSC::JSValue);

#endif


} // namespace WebCore

#endif // ENABLE(MEDIA_STREAM)
